﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace SpreadASP_CRUD_SpreadDataSource
{
    public partial class SpreadDataSource_Binding : System.Web.UI.Page
    {
        DataView employeesView, officesView;
        protected void Page_Load(object sender, EventArgs e)
        {
            FpSpread1.ActiveSheetView.AllowInsert = true;
            FpSpread1.ActiveSheetView.AllowDelete = true;
            FpSpread1.ActiveSheetView.Protect = true;
            FpSpread1.ActiveSheetView.Columns[0].Locked = true;

            employeesView = (DataView)SqlDataSource1.Select(DataSourceSelectArguments.Empty);
            officesView = (DataView)SqlDataSource2.Select(DataSourceSelectArguments.Empty);
            
            FarPoint.Web.Spread.ComboBoxCellType cb = new FarPoint.Web.Spread.ComboBoxCellType();
            cb.DataSource = officesView;
            cb.ShowButton = true;
            cb.DataMember = "Office";
            cb.DataTextField = "officeName";
            cb.DataValueField = "officeID";
            cb.UseValue = true;
            for (int r = 0; r < FpSpread1.ActiveSheetView.RowCount; r++)
            {
                FpSpread1.ActiveSheetView.Cells[r, 3].CellType = cb;
            }
            FpSpread1.ActiveSheetView.Columns[1].Width = 200;
            FpSpread1.ActiveSheetView.Columns[3].Width = 200;
            FpSpread1.ActiveSheetView.Columns[4].Width = 300;
        }

        protected void FpSpread1_UpdateCommand(object sender, FarPoint.Web.Spread.SpreadCommandEventArgs e)
        {
            
        }

        protected void FpSpread1_ButtonCommand(object sender, FarPoint.Web.Spread.SpreadCommandEventArgs e)
        {
            if (e.CommandName == "AddRow")
            {
                // Get the row count for use in incrementing the employeeId
                int rowCount = FpSpread1.ActiveSheetView.RowCount;
                // Convert the employeesView DataView to a DataTable
                DataTable dt = employeesView.ToTable();
                // Add a new row to that DataTable
                var newRow = dt.NewRow();
                newRow["EmployeeID"] = (int)(dt.Rows[dt.Rows.Count - 1]["EmployeeID"]) + 1;
                dt.Rows.Add(newRow);

                // Perform the insert with the new DataTable
                SqlDataSource1.InsertParameters["EmployeeID"].DefaultValue = ((int)(dt.Rows[dt.Rows.Count - 1]["EmployeeID"])).ToString();
                SqlDataSource1.Insert();

                // Create the cell types for the new row
                FarPoint.Web.Spread.ComboBoxCellType cb = new FarPoint.Web.Spread.ComboBoxCellType();
                cb.DataSource = officesView;
                cb.ShowButton = true;
                cb.DataMember = "Office";
                cb.DataTextField = "officeName";
                cb.DataValueField = "officeID";
                cb.UseValue = true;
                FpSpread1.ActiveSheetView.Cells[rowCount, 3].CellType = cb;

                FarPoint.Web.Spread.CheckBoxCellType chkbx = new FarPoint.Web.Spread.CheckBoxCellType();
                chkbx.AutoPostBack = false;
                FarPoint.Web.Spread.HyperLinkCellType hl = new FarPoint.Web.Spread.HyperLinkCellType();
                hl.NavigateUrl = FpSpread1.ActiveSheetView.Cells[rowCount, 4].Text;

                // Set those cell types for specific cells in the new row
                FpSpread1.ActiveSheetView.Cells[rowCount, 4].CellType = hl;
                FpSpread1.ActiveSheetView.Cells[rowCount, 5].CellType = chkbx;
            }
            else if (e.CommandName == "DeleteRow")
            {
                // Remove the active row from the Spread instance
                FpSpread1.ActiveSheetView.RemoveRows(FpSpread1.ActiveSheetView.ActiveRow, 1);

                // Delete that row in the DataSource as well
                SqlDataSource1.Delete();
            }
        }

        protected override void Render(System.Web.UI.HtmlTextWriter writer)
        {
            WebControl addBtn = (WebControl)FpSpread1.FindControl("Add");
            addBtn.Attributes.Add("onclick", "javascript:" + this.Page.GetPostBackEventReference(FpSpread1, "AddRow") + "; return false;");

            WebControl deleteBtn = (WebControl)FpSpread1.FindControl("Delete");
            deleteBtn.Attributes.Add("onclick", "javascript:" + this.Page.GetPostBackEventReference(FpSpread1, "DeleteRow") + "; return false;");

            base.Render(writer);
        }

        protected void FpSpread1_CreateButton(object sender, FarPoint.Web.Spread.CreateButtonEventArgs e)
        {
            if (e.Command == "Insert")
            {
                e.Visible = false;
            }
        }
    }
}